## API Report File for "@fluentui/make-styles"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Properties } from 'csstype';

// @internal
export function __styles<Slots extends string>(classesMapBySlot: CSSClassesMapBySlot<Slots>, cssRules: CSSRulesByBucket): (options: Pick<MakeStylesOptions, 'dir' | 'renderer'>) => Record<Slots, string>;

// Warning: (ae-internal-missing-underscore) The name "createCSSVariablesProxy" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export function createCSSVariablesProxy(prefix?: string): unknown;

// @public
export function createDOMRenderer(target?: Document | undefined): MakeStylesRenderer;

// @public (undocumented)
export type CSSClasses = /* ltrClassName */ string | [/* ltrClassName */ string, /* rtlClassName */ string];

// @public (undocumented)
export type CSSClassesMap = Record<PropertyHash, CSSClasses>;

// @public (undocumented)
export type CSSClassesMapBySlot<Slots extends string | number> = Record<Slots, CSSClassesMap>;

// @public (undocumented)
export type CSSRulesByBucket = Partial<Record<StyleBucketName, string[]>>;

// Warning: (ae-internal-missing-underscore) The name "DEFINITION_LOOKUP_TABLE" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const DEFINITION_LOOKUP_TABLE: Record<SequenceHash, LookupItem>;

// Warning: (ae-internal-missing-underscore) The name "HASH_PREFIX" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const HASH_PREFIX = "f";

// Warning: (ae-internal-missing-underscore) The name "LOOKUP_DEFINITIONS_INDEX" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const LOOKUP_DEFINITIONS_INDEX = 0;

// Warning: (ae-internal-missing-underscore) The name "LOOKUP_DIR_INDEX" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const LOOKUP_DIR_INDEX = 1;

// @public (undocumented)
export type LookupItem = [/* definitions */ CSSClassesMap, /* dir */ /* dir */ 'rtl' | 'ltr'];

// @public (undocumented)
export type MakeStaticStyles = ({
    [key: string]: Properties & Record<string, any>;
} & {
    '@font-face'?: {
        fontFamily: string;
        src: string;
        fontFeatureSettings?: string;
        fontStretch?: string;
        fontStyle?: string;
        fontVariant?: string;
        fontVariationSettings?: string;
        fontWeight?: number | string;
        unicodeRange?: string;
    };
}) | string;

// @public
export function makeStaticStyles(styles: MakeStaticStyles | MakeStaticStyles[]): (options: MakeStaticStylesOptions) => void;

// @public (undocumented)
export interface MakeStaticStylesOptions {
    // (undocumented)
    renderer: MakeStylesRenderer;
}

// @public (undocumented)
export interface MakeStyles extends Omit<Properties, 'animationName'> {
    // (undocumented)
    [key: string]: any;
    // (undocumented)
    animationName?: object | string;
}

// @public (undocumented)
export function makeStyles<Slots extends string | number, Tokens>(stylesBySlots: StylesBySlots<Slots, Tokens>, unstable_cssPriority?: number): (options: MakeStylesOptions) => Record<Slots, string>;

// @public (undocumented)
export interface MakeStylesOptions {
    // (undocumented)
    dir: 'ltr' | 'rtl';
    // (undocumented)
    renderer: MakeStylesRenderer;
}

// @public (undocumented)
export interface MakeStylesRenderer {
    // (undocumented)
    id: string;
    // (undocumented)
    insertCSSRules(cssRules: CSSRulesByBucket): void;
    // (undocumented)
    insertionCache: Record<string, StyleBucketName>;
    // (undocumented)
    styleElements: Partial<Record<StyleBucketName, HTMLStyleElement>>;
}

// @public (undocumented)
export type MakeStylesStyleFunctionRule<Tokens> = (tokens: Tokens) => MakeStyles;

// @public (undocumented)
export type MakeStylesStyleRule<Tokens> = MakeStyles | MakeStylesStyleFunctionRule<Tokens>;

// @public
export function mergeClasses(...classNames: (string | false | undefined)[]): string;

// @public (undocumented)
export type PropertyHash = string;

// @public
export function rehydrateRendererCache(renderer: MakeStylesRenderer, target?: Document | undefined): void;

// Warning: (ae-internal-missing-underscore) The name "resolveProxyValues" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export function resolveProxyValues<T>(value: T): T;

// Warning: (ae-internal-missing-underscore) The name "resolveStyleRules" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export function resolveStyleRules(styles: MakeStyles, unstable_cssPriority?: number): [CSSClassesMap, CSSRulesByBucket];

// @public
export function resolveStyleRulesForSlots<Slots extends string | number, Tokens>(stylesBySlots: StylesBySlots<Slots, Tokens>, unstable_cssPriority: number): [CSSClassesMapBySlot<Slots>, CSSRulesByBucket];

// Warning: (ae-internal-missing-underscore) The name "SEQUENCE_HASH_LENGTH" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const SEQUENCE_HASH_LENGTH = 7;

// Warning: (ae-internal-missing-underscore) The name "SEQUENCE_PREFIX" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const SEQUENCE_PREFIX = "__";

// @public (undocumented)
export type SequenceHash = string;

// @public
export type StyleBucketName = 'd' | 'l' | 'v' | 'w' | 'f' | 'i' | 'h' | 'a' | 'k' | 't';

// @public
export const styleBucketOrdering: StyleBucketName[];

// @public (undocumented)
export type StylesBySlots<Slots extends string | number, Tokens> = Record<Slots, MakeStylesStyleRule<Tokens>>;

// (No @packageDocumentation comment for this package)

```
