## API Report File for "@fluentui/react-accordion"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ARIAButtonProps } from '@fluentui/react-aria';
import { ComponentProps } from '@fluentui/react-utilities';
import { ComponentState } from '@fluentui/react-utilities';
import { Context } from '@fluentui/react-context-selector';
import * as React_2 from 'react';

// @public
export const Accordion: React_2.FunctionComponent<AccordionProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface AccordionCommons extends React_2.HTMLAttributes<HTMLElement> {
    collapsible: boolean;
    multiple: boolean;
    navigable: boolean;
}

// @public (undocumented)
export const AccordionContext: Context<AccordionContextValue>;

// @public (undocumented)
export interface AccordionContextValue {
    // (undocumented)
    navigable: boolean;
    openItems: AccordionItemValue[];
    requestToggle: AccordionToggleEventHandler;
}

// @public (undocumented)
export interface AccordionContextValues {
    // (undocumented)
    accordion: AccordionContextValue;
}

// @public
export const AccordionHeader: React_2.FunctionComponent<AccordionHeaderProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface AccordionHeaderCommons extends Omit<React_2.HTMLAttributes<HTMLElement>, 'children'> {
    expandIconPosition: AccordionHeaderExpandIconPosition;
    inline: boolean;
    size: AccordionHeaderSize;
}

// @public (undocumented)
export interface AccordionHeaderContextValue {
    // (undocumented)
    disabled: boolean;
    // (undocumented)
    expandIconPosition: AccordionHeaderExpandIconPosition;
    // (undocumented)
    open: boolean;
    // (undocumented)
    size: AccordionHeaderSize;
}

// @public (undocumented)
export interface AccordionHeaderContextValues {
    // (undocumented)
    accordionHeader: AccordionHeaderContextValue;
}

// @public (undocumented)
export const AccordionHeaderExpandIcon: React_2.ForwardRefExoticComponent<AccordionHeaderExpandIconProps & React_2.RefAttributes<HTMLSpanElement>>;

// @public (undocumented)
export type AccordionHeaderExpandIconPosition = 'start' | 'end';

// @public (undocumented)
export type AccordionHeaderExpandIconProps = React_2.HTMLAttributes<HTMLSpanElement>;

// @public (undocumented)
export interface AccordionHeaderProps extends ComponentProps<Partial<AccordionHeaderSlots>>, Partial<AccordionHeaderCommons> {
}

// @public
export const accordionHeaderShorthandProps: Array<keyof AccordionHeaderSlots>;

// @public (undocumented)
export type AccordionHeaderSize = 'small' | 'medium' | 'large' | 'extra-large';

// @public (undocumented)
export type AccordionHeaderSlots = {
    button: ARIAButtonProps;
    expandIcon: AccordionHeaderExpandIconProps;
    icon: React_2.HTMLAttributes<HTMLElement>;
    children: React_2.HTMLAttributes<HTMLElement>;
};

// @public (undocumented)
export interface AccordionHeaderState extends ComponentState<AccordionHeaderSlots>, AccordionHeaderCommons, AccordionHeaderContextValue {
    ref: React_2.Ref<HTMLElement>;
}

// @public
export const AccordionItem: React_2.ForwardRefExoticComponent<AccordionItemProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface AccordionItemCommons extends React_2.HTMLAttributes<HTMLElement> {
    disabled: boolean;
}

// @public (undocumented)
export const AccordionItemContext: React_2.Context<AccordionItemContextValue>;

// @public (undocumented)
export interface AccordionItemContextValue {
    // (undocumented)
    disabled: boolean;
    // (undocumented)
    onHeaderClick(ev: React_2.MouseEvent | React_2.KeyboardEvent): void;
    // (undocumented)
    open: boolean;
}

// @public (undocumented)
export interface AccordionItemContextValues {
    // (undocumented)
    accordionItem: AccordionItemContextValue;
}

// @public (undocumented)
export interface AccordionItemProps extends ComponentProps<AccordionItemSlots>, Partial<AccordionItemCommons> {
    value: AccordionItemValue;
}

// @public
export const accordionItemShorthandProps: Array<keyof AccordionItemSlots>;

// @public (undocumented)
export type AccordionItemSlots = {};

// @public (undocumented)
export interface AccordionItemState extends ComponentState<AccordionItemSlots>, AccordionItemCommons, AccordionItemContextValue {
    ref: React_2.Ref<HTMLElement>;
}

// @public (undocumented)
export type AccordionItemValue = unknown;

// @public
export const AccordionPanel: React_2.ForwardRefExoticComponent<AccordionPanelProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface AccordionPanelProps extends ComponentProps<AccordionPanelSlots>, React_2.HTMLAttributes<HTMLElement> {
}

// @public
export const accordionPanelShorthandProps: Array<keyof AccordionPanelSlots>;

// @public (undocumented)
export type AccordionPanelSlots = {};

// @public (undocumented)
export interface AccordionPanelState extends ComponentState<AccordionPanelSlots>, React_2.HTMLAttributes<HTMLElement> {
    open: boolean;
    ref: React_2.Ref<HTMLElement>;
}

// @public (undocumented)
export interface AccordionProps extends ComponentProps<AccordionSlots>, Partial<AccordionCommons> {
    defaultOpenItems?: AccordionItemValue | AccordionItemValue[];
    // (undocumented)
    onToggle?: AccordionToggleEventHandler;
    openItems?: AccordionItemValue | AccordionItemValue[];
}

// @public (undocumented)
export type AccordionSlots = {};

// @public (undocumented)
export interface AccordionState extends ComponentState<AccordionSlots>, AccordionCommons, AccordionContextValue {
    ref: React_2.Ref<HTMLElement>;
}

// @public (undocumented)
export interface AccordionToggleData {
    // (undocumented)
    value: AccordionItemValue;
}

// @public (undocumented)
export type AccordionToggleEvent<E = HTMLElement> = React_2.MouseEvent<E> | React_2.KeyboardEvent<E>;

// @public (undocumented)
export type AccordionToggleEventHandler = (event: AccordionToggleEvent, data: AccordionToggleData) => void;

// @public
export const renderAccordion: (state: AccordionState, contextValues: AccordionContextValues) => JSX.Element;

// @public
export const renderAccordionHeader: (state: AccordionHeaderState, contextValues: AccordionHeaderContextValues) => JSX.Element;

// @public
export const renderAccordionItem: (state: AccordionItemState, contextValues: AccordionItemContextValues) => JSX.Element;

// @public
export const renderAccordionPanel: (state: AccordionPanelState) => JSX.Element | null;

// @public (undocumented)
export const useAccordion: ({ openItems: controlledOpenItems, defaultOpenItems, multiple, collapsible, onToggle, navigable, ...rest }: AccordionProps, ref: React_2.Ref<HTMLElement>) => AccordionState;

// @public (undocumented)
export function useAccordionContextValues(state: AccordionState): AccordionContextValues;

// @public
export const useAccordionHeader: (props: AccordionHeaderProps, ref: React_2.Ref<HTMLElement>) => AccordionHeaderState;

// @public (undocumented)
export function useAccordionHeaderContextValues(state: AccordionHeaderState): AccordionHeaderContextValues;

// @public
export const useAccordionHeaderStyles: (state: AccordionHeaderState) => AccordionHeaderState;

// @public
export const useAccordionItem: ({ value, ...props }: AccordionItemProps, ref: React_2.Ref<HTMLElement>) => AccordionItemState;

// @public (undocumented)
export const useAccordionItemContext: () => AccordionItemContextValue;

// @public (undocumented)
export function useAccordionItemContextValues(state: AccordionItemState): AccordionItemContextValues;

// @public
export const useAccordionPanel: (props: AccordionPanelProps, ref: React_2.Ref<HTMLElement>) => AccordionPanelState;

// @public
export const useAccordionPanelStyles: (state: AccordionPanelState) => AccordionPanelState;

// (No @packageDocumentation comment for this package)

```
