## API Report File for "@fluentui/react-button"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ComponentPropsCompat } from '@fluentui/react-utilities';
import { ComponentStateCompat } from '@fluentui/react-utilities';
import * as React_2 from 'react';
import { ShorthandPropsCompat } from '@fluentui/react-utilities';

// @public
export const Button: React_2.FunctionComponent<ButtonProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export type ButtonDefaultedProps = 'icon' | 'size';

// @public (undocumented)
export type ButtonProps = ComponentPropsCompat & React_2.ButtonHTMLAttributes<HTMLElement> & {
    icon?: ShorthandPropsCompat<React_2.HTMLAttributes<HTMLElement>>;
    block?: boolean;
    circular?: boolean;
    disabled?: boolean;
    disabledFocusable?: boolean;
    iconPosition?: 'before' | 'after';
    outline?: boolean;
    primary?: boolean;
    size?: 'small' | 'medium' | 'large';
    subtle?: boolean;
    transparent?: boolean;
};

// @public (undocumented)
export type ButtonShorthandPropsCompat = 'icon';

// @public
export const buttonShorthandPropsCompat: ButtonShorthandPropsCompat[];

// @public (undocumented)
export interface ButtonState extends ComponentStateCompat<ButtonProps, ButtonShorthandPropsCompat, ButtonDefaultedProps> {
    iconOnly?: boolean;
    ref: React_2.Ref<HTMLElement>;
}

// @public (undocumented)
export interface CheckedState {
    // (undocumented)
    'aria-checked'?: React_2.AriaAttributes['aria-pressed'];
    // (undocumented)
    'aria-pressed'?: React_2.AriaAttributes['aria-pressed'];
    // (undocumented)
    checked?: boolean;
    // (undocumented)
    defaultChecked?: boolean;
    // (undocumented)
    onClick?: React_2.DOMAttributes<HTMLElement>['onClick'];
    // (undocumented)
    role?: string;
}

// @public
export const CompoundButton: React_2.ForwardRefExoticComponent<CompoundButtonProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export type CompoundButtonDefaultedProps = ButtonDefaultedProps | 'contentContainer' | 'secondaryContent';

// @public (undocumented)
export interface CompoundButtonProps extends ButtonProps {
    contentContainer?: ShorthandPropsCompat<React_2.HTMLAttributes<HTMLElement>>;
    secondaryContent?: ShorthandPropsCompat<React_2.HTMLAttributes<HTMLElement>>;
}

// @public (undocumented)
export type CompoundButtonShorthandPropsCompat = ButtonShorthandPropsCompat | 'contentContainer' | 'secondaryContent';

// @public
export const compoundButtonShorthandPropsCompat: CompoundButtonShorthandPropsCompat[];

// @public (undocumented)
export interface CompoundButtonState extends ButtonState, ComponentStateCompat<CompoundButtonProps, CompoundButtonShorthandPropsCompat, CompoundButtonDefaultedProps> {
}

// @public
export const MenuButton: React_2.FunctionComponent<MenuButtonProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export type MenuButtonDefaultedProps = ButtonDefaultedProps | 'menuIcon';

// @public (undocumented)
export type MenuButtonProps = Omit<ButtonProps, 'iconPosition'> & {
    menuIcon?: ShorthandPropsCompat<React_2.HTMLAttributes<HTMLElement>>;
};

// @public (undocumented)
export type MenuButtonShorthandPropsCompat = ButtonShorthandPropsCompat | 'menuIcon';

// @public
export const menuButtonShorthandPropsCompat: MenuButtonShorthandPropsCompat[];

// @public (undocumented)
export interface MenuButtonState extends Omit<ButtonState, 'iconPosition'>, ComponentStateCompat<MenuButtonProps, MenuButtonShorthandPropsCompat, MenuButtonDefaultedProps> {
}

// @public
const renderButton: (state: ButtonState) => JSX.Element;
export { renderButton }
export { renderButton as renderToggleButton }

// @public
export const renderCompoundButton: (state: CompoundButtonState) => JSX.Element;

// @public
export const renderMenuButton: (state: MenuButtonState) => JSX.Element;

// @public
export const ToggleButton: React_2.ForwardRefExoticComponent<ToggleButtonProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export type ToggleButtonDefaultedProps = ButtonDefaultedProps;

// @public (undocumented)
export interface ToggleButtonProps extends ButtonProps {
    checked?: boolean;
    defaultChecked?: boolean;
}

// @public (undocumented)
export type ToggleButtonShorthandPropsCompat = ButtonShorthandPropsCompat;

// @public (undocumented)
export interface ToggleButtonState extends ButtonState, ComponentStateCompat<ToggleButtonProps, ToggleButtonShorthandPropsCompat, ToggleButtonDefaultedProps> {
}

// @public
export const useButton: (props: ButtonProps, ref: React_2.Ref<HTMLElement>, defaultProps?: ButtonProps | undefined) => ButtonState;

// @public
export const useButtonState: (state: ButtonState) => ButtonState;

// @public (undocumented)
export const useButtonStyles: (state: ButtonState) => ButtonState;

// @public
export const useChecked: <TState extends CheckedState>(state: TState) => void;

// @public
export const useCompoundButton: (props: CompoundButtonProps, ref: React_2.Ref<HTMLElement>, defaultProps?: CompoundButtonProps | undefined) => CompoundButtonState;

// @public (undocumented)
export const useCompoundButtonStyles: (state: CompoundButtonState) => CompoundButtonState;

// @public
export const useMenuButton: (props: MenuButtonProps, ref: React_2.Ref<HTMLElement>, defaultProps?: MenuButtonProps | undefined) => MenuButtonState;

// @public (undocumented)
export const useMenuButtonState: (state: MenuButtonState) => MenuButtonState;

// @public (undocumented)
export const useMenuButtonStyles: (state: MenuButtonState) => MenuButtonState;

// @public (undocumented)
export const useToggleButton: (props: ToggleButtonProps, ref: React_2.Ref<HTMLElement>, defaultProps?: ToggleButtonProps | undefined) => ToggleButtonState;

// @public (undocumented)
export const useToggleButtonStyles: (state: ToggleButtonState) => ToggleButtonState;

// (No @packageDocumentation comment for this package)

```
