## API Report File for "@fluentui/react-menu"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ComponentProps } from '@fluentui/react-utilities';
import { ComponentState } from '@fluentui/react-utilities';
import { Context } from '@fluentui/react-context-selector';
import { ContextSelector } from '@fluentui/react-context-selector';
import { ObjectShorthandProps } from '@fluentui/react-utilities';
import { PositioningShorthand } from '@fluentui/react-positioning';
import * as React_2 from 'react';
import { usePopperMouseTarget } from '@fluentui/react-positioning';

// @public
export const Menu: React_2.FC<MenuProps>;

// @public (undocumented)
export const MenuContext: Context<MenuContextValue>;

// @public
export interface MenuContextValue extends MenuListProps, Pick<MenuState, 'openOnHover' | 'openOnContext' | 'triggerRef' | 'menuPopoverRef' | 'setOpen' | 'isSubmenu' | 'triggerId' | 'hasIcons' | 'hasCheckmarks' | 'persistOnItemClick' | 'inline'> {
    // (undocumented)
    open: boolean;
    // (undocumented)
    triggerId: string;
}

// @public (undocumented)
export interface MenuContextValues {
    // (undocumented)
    menu: MenuContextValue;
}

// @public
export const MenuDivider: React_2.FunctionComponent<MenuDividerProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface MenuDividerProps extends ComponentProps, React_2.HTMLAttributes<HTMLElement> {
}

// @public (undocumented)
export interface MenuDividerState extends ComponentState, React_2.HTMLAttributes<HTMLElement> {
    // (undocumented)
    ref: React_2.Ref<HTMLElement>;
}

// @public
export const MenuGroup: React_2.FunctionComponent<MenuGroupProps>;

// @public (undocumented)
export const MenuGroupContextProvider: React_2.Provider<MenuGroupContextValue>;

// @public
export interface MenuGroupContextValue {
    headerId: string;
}

// @public (undocumented)
export interface MenuGroupContextValues {
    // (undocumented)
    menuGroup: MenuGroupContextValue;
}

// @public
export const MenuGroupHeader: React_2.FunctionComponent<MenuGroupHeaderProps>;

// @public (undocumented)
export interface MenuGroupHeaderProps extends ComponentProps, React_2.HTMLAttributes<HTMLElement> {
}

// @public (undocumented)
export interface MenuGroupHeaderState extends ComponentState, React_2.HTMLAttributes<HTMLElement> {
    // (undocumented)
    ref: React_2.Ref<HTMLElement>;
}

// @public (undocumented)
export interface MenuGroupProps extends ComponentProps, React_2.HTMLAttributes<HTMLElement> {
}

// @public (undocumented)
export interface MenuGroupState extends ComponentState, React_2.HTMLAttributes<HTMLElement> {
    headerId: string;
    // (undocumented)
    ref: React_2.Ref<HTMLElement>;
}

// @public
export const MenuItem: React_2.ForwardRefExoticComponent<MenuItemProps & React_2.RefAttributes<HTMLElement>>;

// @public
export const MenuItemCheckbox: React_2.ForwardRefExoticComponent<MenuItemCheckboxProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface MenuItemCheckboxProps extends MenuItemProps, MenuItemSelectableProps {
}

// @public (undocumented)
export interface MenuItemCheckboxState extends MenuItemState, MenuItemSelectableState {
}

// Warning: (ae-forgotten-export) The symbol "MenuItemCommons" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export interface MenuItemProps extends ComponentProps<Partial<MenuItemSlots>>, React_2.HTMLAttributes<HTMLElement>, MenuItemCommons {
}

// @public
export const MenuItemRadio: React_2.ForwardRefExoticComponent<MenuItemRadioProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export interface MenuItemRadioProps extends MenuItemProps, MenuItemSelectableProps {
}

// @public (undocumented)
export interface MenuItemRadioState extends MenuItemState, MenuItemSelectableState {
}

// @public
export interface MenuItemSelectableProps extends React_2.HTMLAttributes<HTMLElement> {
    name: string;
    value: string;
}

// @public
export interface MenuItemSelectableState extends MenuItemSelectableProps {
    checked: boolean;
    checkedItems: string[];
    onCheckedValueChange: (e: React_2.MouseEvent | React_2.KeyboardEvent, name: string, checkedItems: string[]) => void;
}

// @public (undocumented)
export type MenuItemSlots = {
    icon: React_2.HTMLAttributes<HTMLElement>;
    checkmark: React_2.HTMLAttributes<HTMLElement>;
    submenuIndicator: React_2.HTMLAttributes<HTMLElement>;
    content: React_2.HTMLAttributes<HTMLElement>;
    secondaryContent: React_2.HTMLAttributes<HTMLElement>;
};

// @public
export const menuItemSlots: Array<keyof MenuItemSlots>;

// @public (undocumented)
export interface MenuItemState extends ComponentState<MenuItemSlots>, React_2.HTMLAttributes<HTMLElement>, MenuItemCommons {
    ref: React_2.Ref<HTMLElement>;
}

// @public
export const MenuList: React_2.FunctionComponent<MenuListProps & React_2.RefAttributes<HTMLElement>>;

// @public (undocumented)
export const MenuListContext: Context<MenuListContextValue>;

// @public
export interface MenuListContextValue extends Pick<MenuListProps, 'checkedValues' | 'onCheckedValueChange' | 'hasIcons' | 'hasCheckmarks'> {
    // (undocumented)
    selectRadio?: SelectableHandler;
    // (undocumented)
    setFocusByFirstCharacter?: (e: React_2.KeyboardEvent<HTMLElement>, itemEl: HTMLElement) => void;
    // (undocumented)
    toggleCheckbox?: SelectableHandler;
}

// @public (undocumented)
export interface MenuListContextValues {
    // (undocumented)
    menuList: MenuListContextValue;
}

// Warning: (ae-forgotten-export) The symbol "MenuListCommons" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export interface MenuListProps extends ComponentProps, Partial<MenuListCommons> {
}

// @public (undocumented)
export const MenuListProvider: React_2.Provider<MenuListContextValue> & React_2.FC<React_2.ProviderProps<MenuListContextValue>>;

// @public (undocumented)
export interface MenuListState extends ComponentState, MenuListCommons {
    ref: React_2.Ref<HTMLElement>;
    selectRadio: SelectableHandler;
    setFocusByFirstCharacter: NonNullable<MenuListContextValue['setFocusByFirstCharacter']>;
    // (undocumented)
    toggleCheckbox: SelectableHandler;
}

// @public
export interface MenuOpenChangeData extends Pick<MenuState, 'open'> {
    bubble?: boolean;
    keyboard?: boolean;
}

// @public
export type MenuOpenEvents = MouseEvent | TouchEvent | React_2.MouseEvent<HTMLElement> | React_2.KeyboardEvent<HTMLElement> | React_2.FocusEvent<HTMLElement>;

// @public
export const MenuPopover: React_2.ForwardRefExoticComponent<MenuPopoverProps & React_2.RefAttributes<HTMLElement>>;

// @public
export interface MenuPopoverProps extends ComponentProps, React_2.HTMLAttributes<HTMLElement> {
    // (undocumented)
    children: React_2.ReactNode;
}

// @public
export interface MenuPopoverState extends ComponentState, Pick<MenuState, 'inline'>, React_2.HTMLAttributes<HTMLElement> {
    ref: React_2.Ref<HTMLElement>;
}

// Warning: (ae-forgotten-export) The symbol "MenuCommons" needs to be exported by the entry point index.d.ts
//
// @public
export interface MenuProps extends Partial<MenuCommons>, ComponentProps {
    children: [JSX.Element, JSX.Element] | JSX.Element;
    positioning?: PositioningShorthand;
}

// @public (undocumented)
export const MenuProvider: React_2.Provider<MenuContextValue> & React_2.FC<React_2.ProviderProps<MenuContextValue>>;

// @public (undocumented)
export interface MenuState extends MenuCommons, ComponentState {
    contextTarget: ReturnType<typeof usePopperMouseTarget>[0];
    isSubmenu: boolean;
    menuPopover: React_2.ReactNode;
    menuPopoverRef: React_2.MutableRefObject<HTMLElement>;
    menuTrigger: React_2.ReactNode;
    setContextTarget: ReturnType<typeof usePopperMouseTarget>[1];
    setOpen: (e: MenuOpenEvents, data: MenuOpenChangeData) => void;
    triggerId: string;
    triggerRef: React_2.MutableRefObject<HTMLElement>;
}

// @public
export const MenuTrigger: React_2.FC<MenuTriggerProps>;

// @public
export interface MenuTriggerChildProps extends Required<Pick<React_2.HTMLAttributes<HTMLElement>, 'onClick' | 'onMouseEnter' | 'onMouseLeave' | 'onContextMenu' | 'onKeyDown' | 'aria-haspopup' | 'aria-expanded' | 'id'>> {
}

// @public (undocumented)
export const MenuTriggerContextProvider: React_2.Provider<boolean>;

// @public (undocumented)
export interface MenuTriggerProps {
    children: React_2.ReactElement;
}

// @public (undocumented)
export interface MenuTriggerState extends MenuTriggerProps {
}

// @public
export const renderMenu: (state: MenuState, contextValues: MenuContextValues) => JSX.Element;

// @public
export const renderMenuDivider: (state: MenuDividerState) => JSX.Element;

// @public
export const renderMenuGroup: (state: MenuGroupState, contextValues: MenuGroupContextValues) => JSX.Element;

// @public
export const renderMenuGroupHeader: (state: MenuGroupHeaderState) => JSX.Element;

// @public
export const renderMenuItem: (state: MenuItemState) => JSX.Element;

// @public
export const renderMenuItemCheckbox: (state: MenuItemCheckboxState) => JSX.Element;

// @public
export const renderMenuItemRadio: (state: MenuItemRadioState) => JSX.Element;

// @public
export const renderMenuList: (state: MenuListState, contextValues: MenuListContextValues) => JSX.Element;

// @public
export const renderMenuPopover: (state: MenuPopoverState) => JSX.Element;

// @public
export const renderMenuTrigger: (state: MenuTriggerState) => JSX.Element;

// @public (undocumented)
export type SelectableHandler = (e: React_2.MouseEvent | React_2.KeyboardEvent, name: string, value: string, checked: boolean) => void;

// @public (undocumented)
export interface UninitializedMenuListState extends Omit<MenuListState, 'setFocusByFirstCharacter' | 'toggleCheckbox' | 'selectRadio' | 'checkedValues'>, Partial<Pick<MenuListState, 'checkedValues'>> {
}

// @public
export const useCheckmarkStyles: (state: MenuItemSelectableState & {
    checkmark: ObjectShorthandProps<React_2.HTMLAttributes<HTMLElement>>;
}) => void;

// @public
export const useMenu: (props: MenuProps) => MenuState;

// @public (undocumented)
export const useMenuContext: <T>(selector: ContextSelector<MenuContextValue, T>) => T;

// @public (undocumented)
export function useMenuContextValues(state: MenuState): MenuContextValues;

// @public
export const useMenuDivider: (props: MenuDividerProps, ref: React_2.Ref<HTMLElement>) => MenuDividerState;

// @public (undocumented)
export const useMenuDividerStyles: (state: MenuDividerState) => MenuDividerState;

// @public
export function useMenuGroup(props: MenuGroupProps, ref: React_2.Ref<HTMLElement>): MenuGroupState;

// @public (undocumented)
export const useMenuGroupContext: () => MenuGroupContextValue;

// @public (undocumented)
export function useMenuGroupContextValues(state: MenuGroupState): MenuGroupContextValues;

// @public
export function useMenuGroupHeader(props: MenuGroupHeaderProps, ref: React_2.Ref<HTMLElement>): MenuGroupHeaderState;

// @public (undocumented)
export const useMenuGroupHeaderStyles: (state: MenuGroupHeaderState) => MenuGroupHeaderState;

// @public
export const useMenuItem: (props: MenuItemProps, ref: React_2.Ref<HTMLElement>) => MenuItemState;

// @public
export const useMenuItemCheckbox: (props: MenuItemCheckboxProps, ref: React_2.Ref<HTMLElement>) => MenuItemCheckboxState;

// @public
export const useMenuItemRadio: (props: MenuItemRadioProps, ref: React_2.Ref<HTMLElement>) => MenuItemRadioState;

// @public
export const useMenuItemStyles: (state: MenuItemState) => void;

// @public
export const useMenuList: (props: MenuListProps, ref: React_2.Ref<HTMLElement>) => MenuListState;

// @public (undocumented)
export const useMenuListContext: <T>(selector: ContextSelector<MenuListContextValue, T>) => T;

// @public (undocumented)
export function useMenuListContextValues(state: MenuListState): MenuListContextValues;

// @public
export const useMenuPopover: (props: MenuPopoverProps, ref: React_2.Ref<HTMLElement>) => MenuPopoverState;

// @public
export const useMenuTrigger: (props: MenuTriggerProps) => MenuTriggerState;

// @public (undocumented)
export const useMenuTriggerContext: () => boolean;

// (No @packageDocumentation comment for this package)

```
