## API Report File for "@fluentui/react-popover"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ComponentPropsCompat } from '@fluentui/react-utilities';
import { ComponentStateCompat } from '@fluentui/react-utilities';
import { Context } from '@fluentui/react-context-selector';
import { ContextSelector } from '@fluentui/react-context-selector';
import { PopperVirtualElement } from '@fluentui/react-positioning';
import { PortalProps } from '@fluentui/react-portal';
import { PositioningShorthand } from '@fluentui/react-positioning';
import * as React_2 from 'react';

// @public (undocumented)
export const arrowHeights: Record<PopoverSize, number>;

// @public
export interface OnOpenChangeData extends Pick<PopoverState, 'open'> {
}

// @public
export type OpenPopoverEvents = MouseEvent | TouchEvent | React_2.MouseEvent<HTMLElement> | React_2.KeyboardEvent<HTMLElement> | React_2.FocusEvent<HTMLElement>;

// @public
export const Popover: React_2.FC<PopoverProps>;

// @public (undocumented)
export const PopoverContext: Context<PopoverContextValue>;

// @public
export interface PopoverContextValue extends Pick<PopoverState, 'open' | 'setOpen' | 'triggerRef' | 'contentRef' | 'openOnHover' | 'openOnContext' | 'mountNode' | 'noArrow' | 'arrowRef' | 'size' | 'brand' | 'inverted' | 'trapFocus'> {
}

// @public
export type PopoverDefaultedProps = never;

// @public
export interface PopoverProps extends Pick<PortalProps, 'mountNode'> {
    brand?: boolean;
    // (undocumented)
    children: React_2.ReactNode;
    defaultOpen?: boolean;
    inverted?: boolean;
    noArrow?: boolean;
    onOpenChange?: (e: OpenPopoverEvents, data: OnOpenChangeData) => void;
    open?: boolean;
    openOnContext?: boolean;
    openOnHover?: boolean;
    positioning?: PositioningShorthand;
    size?: PopoverSize;
    trapFocus?: boolean;
}

// @public
export type PopoverShorthandProps = never;

// @public
export type PopoverSize = 'small' | 'medium' | 'large';

// @public
export interface PopoverState extends ComponentStateCompat<PopoverProps, PopoverShorthandProps, PopoverDefaultedProps> {
    arrowRef: React_2.MutableRefObject<HTMLDivElement | null>;
    contentRef: React_2.MutableRefObject<HTMLElement | null>;
    contextTarget: PopperVirtualElement | undefined;
    open: boolean;
    setContextTarget: React_2.Dispatch<PopperVirtualElement | undefined>;
    setOpen: (e: OpenPopoverEvents, open: boolean) => void;
    // (undocumented)
    size: NonNullable<PopoverProps['size']>;
    triggerRef: React_2.MutableRefObject<HTMLElement | null>;
}

// @public
export const PopoverSurface: React_2.ForwardRefExoticComponent<PopoverSurfaceProps & React_2.RefAttributes<HTMLElement>>;

// @public
export type PopoverSurfaceDefaultedProps = never;

// @public
export interface PopoverSurfaceProps extends ComponentPropsCompat, React_2.HTMLAttributes<HTMLElement> {
}

// @public
export type PopoverSurfaceShorthandProps = never;

// @public
export interface PopoverSurfaceState extends ComponentStateCompat<PopoverSurfaceProps, PopoverSurfaceShorthandProps, PopoverSurfaceDefaultedProps>, Pick<PopoverContextValue, 'open' | 'mountNode' | 'noArrow' | 'size' | 'brand' | 'inverted'> {
    arrowClassName?: string;
    arrowRef?: React_2.Ref<HTMLDivElement>;
    // (undocumented)
    ref: React_2.Ref<HTMLElement>;
}

// @public
export const PopoverTrigger: React_2.FC<PopoverTriggerProps>;

// @public
export interface PopoverTriggerProps {
    // (undocumented)
    children: React_2.ReactElement;
}

// @public
export interface PopoverTriggerState extends PopoverTriggerProps {
}

// @public
export const renderPopover: (state: PopoverState) => JSX.Element;

// @public
export const renderPopoverSurface: (state: PopoverSurfaceState) => JSX.Element | null;

// @public
export const renderPopoverTrigger: (state: PopoverTriggerState) => JSX.Element;

// @public
export const usePopover: (props: PopoverProps, defaultProps?: PopoverProps | undefined) => PopoverState;

// @public (undocumented)
export const usePopoverContext: <T>(selector: ContextSelector<PopoverContextValue, T>) => T;

// @public
export const usePopoverSurface: (props: PopoverSurfaceProps, ref: React_2.Ref<HTMLElement>, defaultProps?: PopoverSurfaceProps | undefined) => PopoverSurfaceState;

// @public
export const usePopoverSurfaceStyles: (state: PopoverSurfaceState) => PopoverSurfaceState;

// @public
export const usePopoverTrigger: (props: PopoverTriggerProps, defaultProps?: PopoverTriggerProps | undefined) => PopoverTriggerState;

// (No @packageDocumentation comment for this package)

```
