## API Report File for "@fluentui/react-tooltip"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { ComponentPropsCompat } from '@fluentui/react-utilities';
import { ComponentStateCompat } from '@fluentui/react-utilities';
import { PositioningShorthand } from '@fluentui/react-positioning';
import * as React_2 from 'react';
import { ShorthandPropsCompat } from '@fluentui/react-utilities';

// @public
export interface OnVisibleChangeData {
    // (undocumented)
    visible: boolean;
}

// @public
export const renderTooltip: (state: TooltipState) => JSX.Element;

// @public
export const Tooltip: React_2.ForwardRefExoticComponent<TooltipProps & React_2.RefAttributes<HTMLElement>>;

// @public
export type TooltipDefaultedProps = 'showDelay' | 'hideDelay' | 'content' | 'triggerAriaAttribute';

// @public
export interface TooltipProps extends ComponentPropsCompat, React_2.HTMLAttributes<HTMLElement> {
    children?: (React_2.ReactElement<React_2.HTMLAttributes<HTMLElement>> & {
        ref?: React_2.Ref<unknown>;
    }) | ((props: TooltipTriggerProps) => React_2.ReactNode) | null;
    content: ShorthandPropsCompat<ComponentPropsCompat>;
    hideDelay?: number;
    inverted?: boolean;
    onVisibleChange?: (event: React_2.PointerEvent<HTMLElement> | React_2.FocusEvent<HTMLElement> | undefined, data: OnVisibleChangeData) => void;
    pointing?: boolean;
    positioning?: PositioningShorthand;
    showDelay?: number;
    triggerAriaAttribute?: 'label' | 'labelledby' | 'describedby' | null;
    visible?: boolean;
}

// @public
export type TooltipShorthandProps = 'content';

// @public
export const tooltipShorthandProps: TooltipShorthandProps[];

// @public
export interface TooltipState extends ComponentStateCompat<TooltipProps, TooltipShorthandProps, TooltipDefaultedProps> {
    arrowClassName?: string;
    arrowRef?: React_2.Ref<HTMLDivElement>;
    ref: React_2.Ref<HTMLElement>;
    shouldRenderTooltip?: boolean;
}

// @public
export type TooltipTriggerProps = {
    ref?: React_2.Ref<never>;
} & Pick<React_2.HTMLAttributes<HTMLElement>, 'onPointerEnter' | 'onPointerLeave' | 'onFocus' | 'onBlur' | 'aria-describedby' | 'aria-labelledby' | 'aria-label'>;

// @public
export const useTooltip: (props: TooltipProps, ref: React_2.Ref<HTMLElement>, defaultProps?: TooltipProps | undefined) => TooltipState;

// @public
export const useTooltipStyles: (state: TooltipState) => TooltipState;

// (No @packageDocumentation comment for this package)

```
